=== debian/changelog ===
rustc (1.19.0+dfsg3-3ubuntu1~16.04.1+8.0trisquel1) flidas; urgency=medium

  * Backported from http://ppa.launchpad.net/ubuntu-mozilla-
    security/ppa/ubuntu

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 19 Nov 2017 16:36:34 +0000

rustc (1.19.0+dfsg3-3ubuntu1~16.04.1) xenial; urgency=medium

  * Backport 1.19.0 to xenial
  * Relax llvm-toolchain-4.0 build dependency
  * Relax the gdb requirement and don't build-conflict on gdb-minimal
  * Relax the dependency on xz-utils by commenting out some unused code
    - add debian/patches/d-relax-xz-utils-dependency.patch
    - update debian/patches/series
    - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Mon, 23 Oct 2017 19:29:08 +0100

rustc (1.19.0+dfsg3-3ubuntu1) artful; urgency=medium

  * Merge from Debian, remaining changes:
    - Backport patch to fix unaligned access in LTO on armhf
      + add debian/patches/u-fix-unaligned-access-in-lto.patch
      + update debian/patches/series

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 11 Oct 2017 14:00:38 +0100

rustc (1.19.0+dfsg3-3) unstable; urgency=medium

  * Fix a trailing whitespace for tidy.

 -- Ximin Luo <infinity0@debian.org>  Tue, 19 Sep 2017 16:09:41 +0200

rustc (1.19.0+dfsg3-2) unstable; urgency=medium

  * Upload to unstable.
  * Add a patch to print extra information when tests fail.

 -- Ximin Luo <infinity0@debian.org>  Tue, 19 Sep 2017 12:32:03 +0200

rustc (1.19.0+dfsg3-1) experimental; urgency=medium

  * New upstream release.
  * Upgrade to LLVM 4.0. (Closes: #873421)
  * rust-src: install Debian patches as well

 -- Ximin Luo <infinity0@debian.org>  Fri, 15 Sep 2017 04:02:09 +0200
