## rustc 1.22.1+dfsg1+llvm

=== debian/changelog ===
rustc (1.22.1+dfsg1+llvm-0ubuntu2~14.04.2) trusty; urgency=medium

  * Backport 1.22.1 to trusty
  * Build-depend on rustc <= 1.22.1++
  * Relax the gdb requirement and don't build-conflict on gdb-minimal
    - update debian/control
  * Relax the dependency on xz-utils by commenting out some unused code
    - add debian/patches/d-relax-xz-utils-dependency.patch
    - update debian/patches/series
    - update debian/rules
  * Relax dpkg-dev requirement to 1.17.5
   - update debian/control
  * Relax binutils requirement. Even though previous uploads have depended
    on a binutils-2.26, we've never actually used it
    - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 05 Dec 2017 23:36:38 +0000

rustc (1.22.1+dfsg1+llvm-0ubuntu2) bionic; urgency=medium

  * Merge from Debian experimental, remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Fix some test failures that occur because we build rust without an rpath
      - add debian/patches/make-tests-work-without-rpath.patch
      - update debian/patches/series
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Disable debuginfo when building on 32-bit architectures, as it seems to
      be the only way we can get a successful build
      - update debian/config.toml.in
      - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 29 Nov 2017 16:32:51 +0000

rustc (1.22.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Fix symlink target. (Closes: #877276)

 -- Ximin Luo <infinity0@debian.org>  Sat, 25 Nov 2017 22:29:12 +0100

rustc (1.21.0+dfsg1-3) unstable; urgency=medium

  * Add/fix detection for sparc64, thanks to John Paul Adrian Glaubitz.
  * Workaround FTBFS when building docs. (Closes: #880262)

 -- Ximin Luo <infinity0@debian.org>  Mon, 06 Nov 2017 10:03:32 +0100

rustc (1.21.0+dfsg1+llvm-0ubuntu5) bionic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Use the bundled llvm, as target_feature depends on a rust-specific llvm
      API. This also means we have a different tarball to reinclude the llvm
      parts, although we could probably do this with a supplementary tarball
      in future
      - update debian/control
      - update debian/rules
      - update debian/config.toml.in
    - Fix some test failures that occur because we build rust without an rpath
      - add debian/patches/make-tests-work-without-rpath.patch
      - update debian/patches/series
    - Set build.full-bootstrap to true to work-around a runtime link failure
      when we're bootstrapping from the same rust version
      - update debian/config.toml.in

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 26 Oct 2017 18:00:24 +0100

rustc (1.21.0+dfsg1-2) unstable; urgency=medium

  * Upload to unstable.
  * Fix bootstrapping using 1.21.0, which is more strict about redundant &mut
    previously used in u-output-failed-commands.patch.
  * Only allow up to 5 test failures.

 -- Ximin Luo <infinity0@debian.org>  Wed, 25 Oct 2017 20:27:30 +0200

rustc (1.21.0+dfsg1-1) experimental; urgency=medium

  * New upstream release.
  * Fix the "install" target for cross-compilations; cross-compiling with
    sbuild --host=$foreign-arch should work again.
  * Update to latest Standards-Version; changes:
    - Priority changed to optional from extra.

 -- Ximin Luo <infinity0@debian.org>  Tue, 17 Oct 2017 00:42:54 +0200

rustc (1.20.0+dfsg1-3) unstable; urgency=medium

  * Disable jemalloc to fix FTBFS with 1.21 on armhf.

 -- Ximin Luo <infinity0@debian.org>  Wed, 25 Oct 2017 12:01:19 +0200

rustc (1.20.0+dfsg1-2) unstable; urgency=medium

  * Update changelog entry for 1.20.0+dfsg1-1 to reflect that it was actually
    and accidentally uploaded to unstable. No harm, no foul.
  * We are no longer failing the build when tests fail, see NEWS or
    README.Debian for details.
  * Bump LLVM requirement to fix some failing tests.

 -- Ximin Luo <infinity0@debian.org>  Sat, 21 Oct 2017 14:20:17 +0200

rustc (1.20.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 15 Oct 2017 23:30:35 +0200

rustc (1.19.0+dfsg3-4) unstable; urgency=medium

  * Bump LLVM requirement to pull in a fix for a FTBFS on ppc64el.

 -- Ximin Luo <infinity0@debian.org>  Sun, 15 Oct 2017 21:31:03 +0200

rustc (1.20.0+dfsg0-0ubuntu1) artful; urgency=medium

  * Update to 1.20.0
    - update debian/control
    - libstd-rust-1.19.lintian-overrides
      => libstd-rust-1.20.lintian-overrides

  * update debian/copyright
  * Drop patches that are fixed upstream
    - remove debian/patches/u-only-run-linkchecker-if-docs.patch
    - remove debian/patches/u-skip-main-thread-stack-guard.patch
    - remove debian/patches/u-fix-backtrace-build.patch
    - remove debian/patches/u-ignoretest-arm64_02.patch
    - update debian/patches/series
  * Refresh patches
    - update debian/patches/u-ignoretest-ppc64el_03.patch
    - update debian/patches/u-output-failed-commands.patch
    - update debian/patches/u-allow-stable-features.patch

