=== debian/control ===
--- 
+++ 
@@ -1,43 +1,36 @@
 Source: rustc
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
 Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
  Luca Bruno <lucab@debian.org>,
  Sylvestre Ledru <sylvestre@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>
-#  annotations are to support cross-compiling, see README.Debian
+# :native annotations are to support cross-compiling, see README.Debian
 Build-Depends: debhelper (>= 9),
-               dpkg-dev (>= 1.17.14),
-               python,
-               cargo (>= 0.19.0)      <!pkg.rustc.dlstage0>,
-               rustc (>= 1.18.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc (<= 1.19.0++)    <!pkg.rustc.dlstage0>,
-               llvm-4.0-dev   (>= 1:4.0.1-0ubuntu0.16.04.3~),
-               llvm-4.0-tools (>= 1:4.0.1-0ubuntu0.16.04.3~),
-               libllvm4.0            (>= 1:4.0.1-0ubuntu0.16.04.3~),
+               dpkg-dev (>= 1.17.5),
+               python:native,
+               cargo:native (>= 0.19.0)      <!pkg.rustc.dlstage0>,
+               rustc:native (>= 1.21.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.22.1++)    <!pkg.rustc.dlstage0>,
                autotools-dev,
                cmake (>= 3.0) | cmake3,
                gperf,
 # this is sometimes needed by rustc_llvm
-               zlib1g-dev,
+               zlib1g-dev:native,
                zlib1g-dev,
 # used by rust-installer
-               liblzma-dev,
+               liblzma-dev:native,
+# Required for llvm build
+               m4,
 # test dependencies:
-               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
-               nodejs <!nocheck>,
-               valgrind <!nocheck>,
+               binutils <!nocheck>,
                git <!nocheck>,
                procps <!nocheck>,
 # below are optional tools even for 'make check'
-               antlr4 <!nocheck> | antlr <!nocheck>,
-               bison <!nocheck>,
-               flex <!nocheck>,
                gdb <!nocheck>,
-               default-jdk-headless <!nocheck> | default-jdk <!nocheck>,
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://anonscm.debian.org/git/pkg-rust/rust.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git
@@ -47,7 +40,7 @@
 Multi-Arch: allowed
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
- gcc, libc-dev, binutils (>= 2.26)
+ gcc, libc-dev, binutils
 Recommends: rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src
 Description: Rust systems programming language
@@ -63,7 +56,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.19
+Package: libstd-rust-1.22
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -88,7 +81,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libstd-rust-1.19 (= ${binary:Version})
+Depends: ${misc:Depends}, libstd-rust-1.22 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -171,7 +164,6 @@
  standard library documentation.
 
 Package: rust-src
-Section: devel
 Architecture: all
 Depends: ${misc:Depends}
 Description: Rust systems programming language - source code
