=== debian/rules ===
--- 
+++ 
@@ -41,16 +41,6 @@
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
-# These are the normal build flags. Upstream is moving to debian/config.toml
-# but at the current version not all of these flags are available in that file.
-# Certain flags also need to be kept here *as well as* debian/config.toml.in
-# because of https://github.com/rust-lang/rust/issues/43295
-DEB_CONFIGURE_FLAGS = --enable-llvm-link-shared --disable-dist-src --prefix=/usr --release-channel=$(RELEASE_CHANNEL) --disable-debuginfo-only-std
-
-# Use system LLVM (comment out to use vendored LLVM)
-LLVM_VERSION = 4.0
-OLD_LLVM_VERSION = 3.9
-DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-$(LLVM_VERSION)
 RUSTBUILD = RUST_BACKTRACE=1 ./x.py
 RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
 # TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
@@ -76,6 +66,7 @@
 #
 PRECONFIGURE_CHECK = :
 HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
+DOWNLOAD_BOOTSTRAP := false
 # allow not using the binary tarball although it exists
 #ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
 #  HAVE_BINARY_TARBALL := 0
@@ -89,12 +80,19 @@
     # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
     # In this case, we use the distro's rustc - either the previous or current version.
     ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
-        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
-    endif
+        # Make it easier to test against a custom rustc
+        ifneq (,$(RUST_DESTDIR))
+        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
+        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
+        export LD_LIBRARY_PATH
+        endif
     #
     # Case A-2: the builder selected the "dlstage0" build profile.
     # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
     # We don't need to do anything specific in this build file, so this case is empty.
+    else
+        DOWNLOAD_BOOTSTRAP := true
+    endif
 else
     # Case B (Bootstrapping a new distro): the extracted source tree does
     # include a bootstrapping tarball for the current architecture; see the
@@ -111,14 +109,21 @@
     endif
 endif
 
-BUILD_DOCS = 1
+BUILD_DOCS := true
 ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
-  DEB_CONFIGURE_FLAGS += --disable-docs
-  BUILD_DOCS =
+  BUILD_DOCS := false
 endif
 
+MAKE_OPTIMISATIONS := true
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
+  MAKE_OPTIMISATIONS := false
+endif
+
+BUILD_DEBUGINFO := true
+ifeq (32,$(DEB_BUILD_ARCH_BITS))
+# Building with no debuginfo seems to be the only way to get a
+# successful build on 32-bit build machines
+  BUILD_DEBUGINFO := false
 endif
 
 # Build products or non-source files in src/, that shouldn't go in rust-src
@@ -139,40 +144,39 @@
 	$(SYSTEM_WORKAROUNDS) dh $@ --parallel
 
 override_dh_clean:
-	dh_clean -Xsrc/vendor/bitflags/Cargo.toml.orig
-
-debian/configure-upstream: debian/config.toml debian/rules
-	rm -f "$@"
-	echo '#!/bin/sh' >> "$@"
-	echo '# This script can be used to configure a mostly-clean upstream checkout' >> "$@"
-	echo '# in case you need to test any differences between it and Debian' >> "$@"
-	echo 'set -e' >> "$@"
-	echo 'test -f ./configure' >> "$@"
-	echo 'cat > config.toml <<EOF' >> "$@"
-	cat debian/config.toml >> "$@"
-	echo 'EOF' >> "$@"
-	echo "./configure $(DEB_CONFIGURE_FLAGS)" >> "$@"
-	chmod +x "$@"
+	# Upstream contains a lot of these
+	dh_clean -XCargo.toml.orig
 
 debian/config.toml: debian/config.toml.in
 	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
 		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
 		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
 		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
-		-DLLVM_VERSION="$(LLVM_VERSION)" \
+		-DBUILD_DOCS="$(BUILD_DOCS)" \
+		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
+		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
+		-DBUILD_DEBUGINFO="$(BUILD_DEBUGINFO)" \
 		"$<" > "$@"
+	! $(DOWNLOAD_BOOTSTRAP) || sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"
 
 debian/rust-src.%: debian/rust-src.%.in
 	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
 		"$<" > "$@"
 
 override_dh_auto_configure: debian/config.toml
-	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
-	! grep --color=always -i 'll...\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog -R debian
 	$(PRECONFIGURE_CHECK)
 	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
 	# work around #842634
 	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
 	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
 	# We patched mdbook and xz2 so have to rm the checksums
-	debian/empty-cargo-checksum.py src/vendor/mdbook/.cargo-checksum.json
+	debian/prune-checksums src/vendor/mdbook/.cargo-checksum.json
+	debian/prune-checksums src/vendor/xz2/.cargo-checksum.json
+	# Unfortunately upstream uses a duplicate copy of libbacktrace and wants to
+	# compile it again for rust-installer, see #43449
+	ln -rsf src/libbacktrace -t src/vendor/backtrace-sys/src/
+	debian/prune-checksums src/vendor/backtrace-sys/.cargo-checksum.json
+	# Link against system liblzma, see https://github.com/alexcrichton/xz2-rs/issues/16
+	echo 'fn main() { println!("cargo:rustc-link-lib=lzma"); }' > src/vendor/lzma-sys/build.rs
+	debian/prune-checksums src/vendor/lzma-sys/.cargo-checksum.json
+	# We excluded some embedded libraries in d/copyright
